<template>
  <div id="main">
    <h1 class="py-8">Super Calculator App</h1>
    <!--<h2>Last Number</h2>
    <span>{{ lastNumber }}</span>-->
  <div class="border py-8">
    <h2 id="display"> = {{ current }}</h2>

    <br />

    <div class="wrapperCalc">
      <!--This is for the numbers-->
      <button class="border"
        v-for="nkey in numberKeys"
        @click="append(nkey)"
        :key="nkey"
        id="numbers"
      >
        {{ nkey }}
      </button>

      <br />

      <!--This are the operators-->
      <button v-on:click="addNumber" class="operator px-2">+</button>
      <button v-on:click="subtract" class="operator px-2">-</button>
      <button v-on:click="times" class="operator px-2">*</button>
      <button v-on:click="divide" class="operator px-2">÷</button>
    </div>

    <br />

  
    <!--This +/--->
    <button @click="sign" class="other px-2">+/-</button>
    <!--This +/--->
    <button @click="percent" class="other">%</button>
    <!--This is for decimal nmb-->
    <button @click="dot" id="decimal" class="other px-2">.</button>
    <!--This deletes-->
    <button @click="deleteResult" id="delete" class="other px-2">C</button>

    <br />
    <!--This is show result-->
    <button @click="showResult" id="showResult" class="border border-1">=</button>


    </div>

    <img src="http://i.stack.imgur.com/SBv4T.gif" alt="this slowpoke moves"  width="250" id="gif"/>
  </div>
</template>


<script>
const numberKeys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0];

export default {
  data() {
    return {
      lastNumber: "",
      // I re-wrote the array to a string
      current: '',
      numberKeys,
      operator: null, 
      operatorClicked: false,
    };
  },


  methods: {
    append(number){
      if (this.operatorClicked){
        this.current = '';
        this.operatorClicked = false;
      }
      // append the current number to current
      this.current = `${this.current}${number}`;
    },
    setPrevious() {
      this.previous = this.current;
      this.operatorClicked = true;
    },
    addNumber() {
      //this.lastNumber = this.currentNumberString;
      //this.currentNumberArray = [];
      this.operator = (a, b) => a +b;
      this.setPrevious();
    },
    divide() {
      this.operator = (a, b) => a /b;
      this.setPrevious();
    },
    subtract(){
      this.operator = (a, b) => a -b;
      this.setPrevious();
    },
    times() {
      this.operator = (a, b) => a *b;
      this.setPrevious();
    },
    sign() {
      // ternary operator that checks if the first character is a '-' if retrun string without the 1 char else append one
      this.current = this.current.charAt(0) === ['-'] ?
      this.current.slice(1) : `-${this.current}`
    },
    percent() {
      this.current = `${parseFloat(this.current) / 100}`
    },
    dot() {
      if (this.current.indexOf('.') === -1) {
        this.append('.');
      }
    },
    showResult() {
       this.current = `${this.operator(parseFloat(this.previous), parseFloat(this.current))}`
      this.previous = null
    },
    deleteResult() {
      this.current = '';
    },
  },
};
</script>



<style>
#main {
    color: white;
  background-color: #ffafc0;
  font-family: Arial, Helvetica, sans-serif;
  font-weight: bold;
  text-align: center;
  display: flex;
  flex-direction: column;
  align-items: center
  
}

#numbers {
  padding: 6%;
  margin: 1%;
  font-size: 20px;
}

button {
  background-color: white; 
  border: none;
  color: #ffafc0;
  padding: 15px 25px;
  border-radius: 4px;
}

#showResult {
  margin: 2%;
  width: 40%;
  font-size: 20px;
}

.operator{
  font-size: 30px;
  margin: 1%;
}

.border{
  width: 25%;
  border:5px solid rgb(255, 255, 255);
  border-radius: 4px;
}

.other {
  margin-left: 2%;
}

</style>